<template xmlns:v-slot="http://www.w3.org/1999/XSL/Transform">
	<div>
		<el-form :model="inputForm" ref="inputForm" v-loading="loading" :class="method==='view'?'readonly':''" :disabled="(status === 'audit' || status === 'taskFormDetail')"
				 label-width="100px" @submit.native.prevent>

			<el-divider content-position="left"><i class="el-icon-document"></i> 社保信息</el-divider>
			<el-row :gutter="26">
				<el-col :span="12">
					<el-form-item label="姓名" prop="name" :rules="[{required: true, message: '姓名不能为空', trigger: 'blur'}]">
						<el-input v-model="inputForm.name" :disabled="true"></el-input>
					</el-form-item>
				</el-col>
				<el-col :span="12">
					<el-form-item label="所属部门" prop="department" :rules="[
						{required: true, message:'请选择所属部门', trigger: 'blur'}
					]">
						<SelectTree
							ref="officeTree"
							:props="{
										  value: 'id',             // ID字段名
										  label: 'name',         // 显示名称
										  children: 'children'    // 子级字段名
										}"
							:url="`/system-server/sys/office/treeData?type=2`"
							:value="inputForm.department"
							:accordion="true"
							size="large"
							:disabled="true"
							@getValue="(value) => {inputForm.department=value}"/>
					</el-form-item>
				</el-col>
				<el-col :span="12">
					<el-form-item label="项目经理" prop="projectManager"
								  :rules="[
								  	{required: true, message: '项目经理不能为空', trigger: 'change'}
                   ]">
<!--						<UserSelectSignatory style="width: 100%" ref="userSelect1"-->
<!--											 :readonly="true" :limit='1' :modelValue="inputForm.projectManager"-->
<!--											 @update:modelValue='(value, label) => {inputForm.projectManager = value}'></UserSelectSignatory>-->
						<UserSelect2 :limit='1' :modelValue="inputForm.projectManager" @update:modelValue='(value, label) => {inputForm.projectManager = value}'></UserSelect2>
					</el-form-item>
				</el-col>
<!--				<el-col :span="12">-->
<!--					<el-form-item label="底稿管理员" prop="draftAdministrator"-->
<!--								  :rules="[-->
<!--								  	{required: true, message: '底稿管理员不能为空', trigger: 'change'}-->
<!--                   ]">-->
<!--						<UserSelectAll size="medium" :limit='1' :modelValue="inputForm.draftAdministrator" @update:modelValue='(value) => {inputForm.draftAdministrator = value}'></UserSelectAll>-->
<!--					</el-form-item>-->
<!--				</el-col>-->
			</el-row>
			<el-row :gutter="26">
				<el-col :span="12">
					<el-form-item label="备注" prop="remarks" :rules="[]">
						<el-input type="textarea" v-model="inputForm.remarks"></el-input>
					</el-form-item>
				</el-col>
			</el-row>

		</el-form>
	</div>
</template>

<script>
	import SelectTree from '@/components/treeSelect/treeSelect.vue'
	import handoverService from '@/api/human/depart/HandoverService'
	import CommonApi from '@/api/cw/common/CommonApi'
	import UserSelectAll from '@/components/userSelectAll'
	import UserSelect2 from '@/components/userSelect'

	export default {
		props: {
			businessId: {
				type: String,
				default: ''
			},
			formReadOnly: {
				type: Boolean,
				default: false
			},
			status: {
				type: String,
				default: ''
			}
		},
		data () {
			return {
				title: '',
				method: '',
				visible: false,
				loading: false,
				inputForm: {
					userId: '',
					name: '',
					procInsId: '',
					department: '',
					projectManager: '',
					draftAdministrator: '',
					remarks: '',
					registrationId: '',
					type: '',
				},
				keyWatch: '',
			}
		},
		commonApi: null,
		created () {
			this.commonApi = new CommonApi()
		},
		components: {
			SelectTree,
			UserSelectAll,
			UserSelect2,
		},
		computed: {
			bus: {
				get () {
					return this.businessId
				},
				set (val) {
					this.businessId = val
				}
			},
			name () {
				return this.$store.state.user.name
			},
			userId () {
				return this.$store.state.user.id
			}
		},
		watch: {
			'keyWatch': {
				handler (newVal) {
					if (this.commonJS.isNotEmpty(this.bus)) {
						this.init('', this.bus)
					} else {
						this.$nextTick(() => {
							this.$refs.inputForm.resetFields()
						})
					}
				}
			},
			'loading': {
				handler (newVal) {
					this.$emit('changeLoading', newVal)
				}
			}
		},
		methods: {
			getKeyWatch (keyWatch) {
				this.keyWatch = keyWatch
			},
			init (method, id) {
				this.method = method
				this.inputForm = {
					userId: '',
					name: '',
					procInsId: '',
					department: '',
					projectManager: '',
					draftAdministrator: '',
					remarks: '',
					registrationId: '',
					type: '',
				}
				if (method === 'add') {
					this.title = `新建离职申请`
				} else if (method === 'edit') {
					this.title = '修改离职申请信息'
				}
				this.inputForm.id = id
				this.visible = true
				this.loading = false
				this.$nextTick(() => {
					this.loading = true
					handoverService.findById(this.inputForm.id).then((data) => {
						this.fileList = []
						this.fileList2 = []
						if (this.status === 'audit' || this.status === 'taskFormDetail') {
							method = 'view'
						}
						this.inputForm = this.recover(this.inputForm, data)
						this.inputForm = JSON.parse(JSON.stringify(this.inputForm))

						if (this.commonJS.isEmpty(this.inputForm.name)){
							this.inputForm.name = this.$store.state.user.name
						}
						if (this.commonJS.isEmpty(this.inputForm.department)){
							this.inputForm.department = this.$store.state.user.office.id
						}
						this.loading = false
					})
				})
			},
			// 表单提交
			doSubmit () {
				this.$refs['inputForm'].validate((valid) => {
					if (valid) {
						this.loading = true
						if (this.commonJS.isEmpty(this.inputForm.files)) {
							this.inputForm.files = []
						}
						this.inputForm.id = this.businessId
						handoverService.save(this.inputForm).then((data) => {
							this.close()
							this.$message.success(data)
							this.$emit('refreshDataList')
							this.loading = false
						}).catch(() => {
							this.loading = false
						})
					}
				})
			},
			close () {
				this.$refs.inputForm.resetFields()
				this.fileList = []
				this.fileList2 = []
				this.visible = false
			},
			reapplyForm (callback) {
				this.loading = true
				handoverService.findById(this.inputForm.id).then((data) => {
					if (data.type !== '4') { // 审核状态不是“驳回”，就弹出提示
						this.loading = false
						this.$message.error('任务数据已发生改变或不存在，请在待办任务中确认此任务是否存在')
						throw new Error('任务数据已发生改变或不存在，请在待办任务中确认此任务是否存在')
					} else {
						this.startForm(callback)
					}
				})
			},
			//暂存
			saveForm (callback) {
				// 暂存
				this.loading = true
				this.inputForm.type = '1'
				if (this.commonJS.isEmpty(this.inputForm.registrationId)) {
					this.inputForm.registrationId = this.businessId
				}

				handoverService.save(this.inputForm).then((data) => {
					callback(data.businessTable, data.businessId, this.inputForm)
					this.loading = false
				}).catch(() => {
					this.loading = false
				})
			},
			// 送审
			async startForm (callback) {
				this.$refs['inputForm'].validate(async (valid) => {
					if (valid) {
						this.loading = true
						this.inputForm.type = '2'
						if (this.commonJS.isEmpty(this.inputForm.registrationId)) {
							this.inputForm.registrationId = this.businessId
						}
						handoverService.save(this.inputForm).then((data) => {
							this.inputForm.title = `${this.$store.state.user.name} 发起了 [离职交接]`
							this.inputForm.id = data.businessId
							this.inputForm.assignee = this.inputForm.projectManager
							callback(data.businessTable, data.businessId, this.inputForm)
							this.$refs.inputForm.resetFields()
							this.loading = false
						}).catch(() => {
							this.$refs.inputForm.resetFields()
							this.loading = false
						})
					} else {
						this.loading = false
					}
				})
			},

			// 通过
			async agreeForm (callback) {
				this.loading = true
				handoverService.findById(this.inputForm.id).then((data) => {
					if (data.type !== '2') { // 审核状态不是“审核中”，就弹出提示
						this.loading = false
						this.$message.error('任务数据已发生改变或不存在，请在待办任务中确认此任务是否存在')
						throw new Error('任务数据已发生改变或不存在，请在待办任务中确认此任务是否存在')
					} else {
						this.$refs['inputForm'].validate(async (valid) => {
							if (valid) {
								this.loading = true

								this.commonApi.getTaskNameByProcInsId(this.inputForm.procInsId).then((data) => {
									if (this.commonJS.isNotEmpty(data)) {
										if (data === '部门主任审批') {
											this.inputForm.type = '5'
										}
									}
									handoverService.save(this.inputForm).then((data) => {
										callback(data.businessTable, data.businessId, this.inputForm)
										this.loading = false
									}).catch(() => {
										this.loading = false
									})
								})

							} else {
								this.loading = false
							}
						})
					}
				})
			},
			// 修改状态
			updateStatusById (type, callback) {
				if (type === 'reject') {
					this.loading = true
					handoverService.findById(this.inputForm.id).then((data) => {
						console.log('进入了驳回')
						if (data.type !== '2') { // 审核状态不是“审核中”，就弹出提示
							this.loading = false
							this.$message.error('任务数据已发生改变或不存在，请在待办任务中确认此任务是否存在')
							throw new Error('任务数据已发生改变或不存在，请在待办任务中确认此任务是否存在')
						} else {
							this.commonApi.getTaskNameByProcInsId(this.inputForm.procInsId).then((name) => {
								if (this.commonJS.isNotEmpty(name)) {
									if (name === '项目经理审批' || name === '项目经理重新审批') {
										this.inputForm.type = '4'
									}
								}
								handoverService.updateStatusById(this.inputForm).then(() => {
									this.loading = false
									callback()
								})
							})
						}
					})
				} else if (type === 'hold') {
					this.loading = true
					handoverService.findById(this.inputForm.id).then((data) => {
						if (data.type !== '4') { // 审核状态不是“驳回”，就弹出提示
							this.loading = false
							this.$message.error('任务数据已发生改变或不存在，请在待办任务中确认此任务是否存在')
							throw new Error('任务数据已发生改变或不存在，请在待办任务中确认此任务是否存在')
						} else {
							this.inputForm.type = '1'
							handoverService.updateStatusById(this.inputForm).then(() => {
								this.loading = false
								callback()
							})
						}
					})
				}
			},
		}
	}
</script>
